<?php  
#-----------------------------------------------
# CREDIT - DO NOT REMOVE WITHOUT PERMISSION
# VERSION       : 4.00
# Author:       : Wim van der Kuil
# Documentation 
#   and support : https://leuven-template.eu/
#-----------------------------------------------
#             HERE YOU NEED TO MAKE SOME CHANGES 
#-----------------------------------------------
$wustart 	= '31-05-2029';	  // Important the format is:   dd-mm-YYYY  for your first day of uploading data to WU.      !
$wuid		= 'XXXXXXXXXX';	// your WU station name
$WUdatastr      = 'http://_replace_yourwebsite_/_replace folder_/PWS_DailyHistory.php';
#
if ($wustart == '31-05-2029') { die( '<h3 style="color: red;">You should adapt lines 11, 12 and 13 before this script can run</h3>');}
#
$latitude	= '50';		// for the seasons: a positive number for north of the equator, or a negative number for south
#				temp values: ='&deg;C', ='&deg;F'
$uomTemp 	= '&deg;C';		
#$uomTemp 	= '&deg;F';
#				baro values: =' hPa'   ' mb'   ' inHg'
$uomBaro 	= ' hPa';
#$uomBaro 	= ' mb';
#$uomBaro 	= ' inHg';
#				windspeed values: ' km/h'  ' kts'  ' m/s'  ' mph'
$uomWind 	= ' km/h';
#$uomWind 	= ' kts';
#$uomWind 	= ' m/s';
#$uomWind 	= ' mph';
#				rain values:  ' mm'  ' in'
$uomRain	= ' mm';
#$uomRain	= ' in';
#				wind run values: ' km'  ' mi'
$uomWrun	= ' km';
#$uomWrun	= ' mi';
#
$dateLongFormat = 'l d F Y';
#
#		Be carefull changing the following  settings
#
$pagewidth     = '100%';
#
$includeHTML	= true; 		// <head><body><css><scripts> are loaded, if set to false include the CSS also
#
$lang		= 'en';			// your language. If no language file is found 'en' is used
$wsreportsDir	= './';			// folder where the report scripts are located, leave as is if you are running this script from the same folder
$charset	= 'UTF-8';		// 'ISO-8859-1'  'UTF-8'
#
#-----------------------------------------------
#                                END OF SETTINGS 
#-----------------------------------------------
#  display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) 
     {  $filenameReal = __FILE__;			
        $download_size = filesize($filenameReal);
        header('Pragma: public');
        header('Cache-Control: private');
        header('Cache-Control: no-cache, must-revalidate');
        header("Content-type: text/plain");
        header("Accept-Ranges: bytes");
        header("Content-Length: $download_size");
        header('Connection: close');
        readfile($filenameReal);
        exit;}
#-----------------------------------------------
$pageName	= 'startReports.php';
$pageVersion	= '4.02 2020-06-20';
$pageUpdated	= 'PWS version'; 
#--------------------------------------- History
# 4.00 2017-12-16 first version	
# 4.01 2018-07-22 Release version
# 4.02 2020-06-20 PWS version
# ---------------------------------- Houskeeping
$pageLoaded 	= basename(__FILE__); 
$string         = $pageVersion.' | '.$pageUpdated;
if ( $pageName <>  $pageLoaded)  {  $string .= ' => check script name: '.$pageName; } 
#
if (isset($_REQUEST['lang']) )
     {	$lang		= substr( trim($_REQUEST['lang']), 0 , 2 );
	$getLang	= true;}
#
if (!isset ($mypage) ) {$mypage = $pageLoaded;}
$phpselftop     = '';
#
if ($includeHTML) 
    {   $extra  = 'style="width: '.$pagewidth.'; margin: 0 auto;" ';
        echo '<!DOCTYPE html>
<html lang="'.$lang.'">
<head>
<meta http-equiv="Content-Type" content="text/html; charset='.$charset.'" />
<meta name="Keywords" content="weather reports, wunderground, weather history" />
<link rel="stylesheet" href="./wsReports.css" type="text/css">
<style type = "text/css">
 body  {margin: 0px;	font-family: arial; font-size: 9pt;}
 table {font-size: 9pt;}
</style>
<title>'.$wuid.' reports. Script startReports.php</title>
</head>
<body style="background-color: #EEEEEE;">
<div '.$extra.'>'.PHP_EOL;}
#
ws_message ( '<!-- loaded script: '.basename(__FILE__).' ('.__LINE__.'): '.$pageVersion.' | '.$pageUpdated.' -->',true);
ws_message (ws_debug_times( 'module '.basename(__FILE__).' ('.__LINE__.'): '),true);
# 
# error reporting
#
$wsDebug	= false;
if (isset($_REQUEST['debug']) ) 
     {  $wsDebug	= true;
	ini_set('display_errors', 'On'); 
	error_reporting(E_ALL);	
	ws_message ('<!-- module '.basename(__FILE__).' ('.__LINE__.'): debug is switched on by user request - error reporting ALL -->',true);}
#
if (isset ($getLang) && $getLang) 
     {  ws_message ('<!-- module '.basename(__FILE__).' ('.__LINE__.'): $_GET["lang"] = '.$_GET["lang"].' $lang = '.$lang. ' -->',true);}
#
$script = $wsreportsDir.'wsReports1part.php';
ws_message (  '<!-- module '.basename(__FILE__).' ('.__LINE__.'): loading '.$script.' -->');
include $script;
#
if ($includeHTML) {echo '</div>
</body>
</html>';}
else {  echo ws_css_insert ('./wsReports.css',true);}
#
function ws_message ($message, $always=false, &$string=false) 
     {  global $wsDebug, $SITE;
	$echo	= $always;
#	echo $message.$string.'-'.$always; exit;
	if ( $echo == false)
	     {  if ((isset ($wsDebug)            && $wsDebug == true )          
	         || (isset ($SIE['wsDebug'])     && $SIE['wsDebug'] == true ) ) {$echo = true;}}
	if ( $echo == true)
	     {  if ($string === false)  { echo $message.PHP_EOL;}
	        else                    { $string .= $message.PHP_EOL;}}
} // eof ws_message
#

function ws_debug_times($start = '') {
        global $ws_start_time, $ws_passed_time;
        if (!isset ($ws_passed_time)) 
             {  $ws_start_time = $ws_passed_time = microtime(true);
                return  '<!-- '.$start.' Debug timers initialized  -->';}
#
        $now            = microtime(true);
        $since_last     = $now - $ws_passed_time;
        $ws_passed_time = $now;
        
        if ($since_last < 0.0001) {$string1 = '< 0.0001';} else {$string1 = round($since_last,4);}
        $until_last     = $now - $ws_start_time;
        if ($until_last < 0.0001) {$string2 = '< 0.0001';} else {$string2 = round($until_last,4);}
       
        return '<!-- '.$start.' Time spent until here: '.$string2.' seconds. Since last timestamp: '.$string1.' seconds.  -->';
} // eof ws_debug_times

function ws_css_insert ($styles,$sheet = 'n/a')  
     {  $string = '<script>
if(typeof document.createStyleSheet === "undefined") {
    document.createStyleSheet = (function() {
        function createStyleSheet(href) {
            if(typeof href !== "undefined") {
                var element = document.createElement("link");
                element.type = "text/css";
                element.rel = "stylesheet";
                element.href = href;}
            else {
                var element = document.createElement("style");
                element.type = "text/css";}
            document.getElementsByTagName("head")[0].appendChild(element);
            var sheet = document.styleSheets[document.styleSheets.length - 1];
            if(typeof sheet.addRule === "undefined")
               { sheet.addRule = addRule;}
            if(typeof sheet.removeRule === "undefined")
               { sheet.removeRule = sheet.deleteRule;}
            return sheet;
        }
        function addRule(selectorText, cssText, index) {
            if(typeof index === "undefined") { index = this.cssRules.length;}
            this.insertRule(selectorText + " {" + cssText + "}", index);
        }
        return createStyleSheet;
    })();
}';
if ($sheet === 'n/a')
     {  $string .= '
var sheet = document.createStyleSheet();'.PHP_EOL;
        foreach ($styles as $key => $css) 
            {   $string .= 'sheet.addRule("'.$key.'","'.$css.'");'.PHP_EOL;} }
else {  $string .= '
var sheet = document.createStyleSheet("'.$styles.'");'.PHP_EOL;}
$string .= '</script>'.PHP_EOL;
return $string;}